task spladder_merge {
    String sample_id
    File bam
    File pickle
    File reference_gtf_file
    File samples
    

    String docker
    String cluster
    String disk_size

    
    command <<<
       set -o pipefail
        set -e

        mkdir -p ${sample_id}/spladder_out/spladder
        
        ln -s ${bam}/*.bam ./
        cat ${samples} | while read a; do ls ./ | grep bam$ | grep $a; done > alignment.txt
       
        ln -s ${bam}/*.bai ./
        cat ${samples} | while read a; do ls ./ | grep bai$ | grep $a; done > alignment_bai.txt

        ln -s ${pickle}/*.pickle ${sample_id}/spladder_out/spladder/
        cat ${samples} | while read a; do ls ${sample_id}/spladder_out/spladder/ | grep $a; done >> pickle.txt
		
        nt=$(nproc)
		
        spladder build -o ${sample_id}/spladder_out \
          --annotation ${reference_gtf_file} \
          --bams alignment.txt \
          --confidence 2 \
          --merge-strat merge_graphs \
          --readlen 150 \
          --parallel $nt \
          --no-extract-ase
          
          
        find . -depth > fileList.txt
    >>>

    runtime {
        docker: docker
        cluster: cluster
        systemDisk: "cloud_ssd 50"
        dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/"
    }

    output {
        File fileList = "fileList.txt"
        File alignment = "alignment.txt"
        File alignment_bai = "alignment_bai.txt"
        File pickle_txt = "pickle.txt"
        File AS_merge_pickle = "${sample_id}/spladder_out/spladder/genes_graph_conf2.merge_graphs.pickle"
    }
}